unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TxReplaceFlags = set of (rfReplaceAll, rfIgnoreCase, rfSelectLast);

type
  TForm1 = class(TForm)
    Label2: TLabel;
    Button1: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    CheckBox1: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    xFlag: TxReplaceFlags;
    function AddrReplace(S: string;
                         OldPattern, NewPattern, DefPattern: TStringList;
                         Flags: TxReplaceFlags): string;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.AddrReplace(S: string;
                            OldPattern, NewPattern, DefPattern: TStringList;
                            Flags: TxReplaceFlags): string;
         var S1, SearchStr, Patt, NewStr: string;
             Offset, Offset1, Offset2, Offset3: integer;
             chng: boolean;
             i,j: integer;
begin
  if OldPattern.Count <> NewPattern.Count then begin
     Application.MessageBox('sഫrq!','~',MB_OK);
     exit;
  end;

  Memo1.Clear;
  Memo1.Lines.Add(S);
  Memo1.Lines.Add('');
  // ˬdO_ĥDefPattern ̫mrꤧ~}l
  if rfSelectLast in Flags then begin
     if rfIgnoreCase in Flags then SearchStr:= AnsiUpperCase(S)
     else SearchStr:= S;
     Offset1:= 0;
     for i:= 0 to DefPattern.Count-1 do begin
         if rfIgnoreCase in Flags then Patt:= AnsiUpperCase(DefPattern[i])
         else Patt:= DefPattern[i];
         Offset:= AnsiPos(Patt, SearchStr);
         if Offset > 0 then begin
            if Offset1<Offset then Offset1:= Offset;
         end;
     end;
     S1:= Copy(S, 1, Offset1+Length(Patt)-1);
      S:= Copy(S, Offset1+Length(Patt), MaxInt);
  end;

  for i:= 0 to OldPattern.Count-1 do begin
      if rfIgnoreCase in Flags then begin
         SearchStr:= AnsiUpperCase(S);
         Patt:= AnsiUpperCase(OldPattern[i]);
      end
      else begin
        SearchStr:= S;
        Patt:= OldPattern[i];
      end;
      NewStr:= S;
      Result:= '';
      while SearchStr <> '' do begin
        Offset:= AnsiPos(Patt, SearchStr);
        if Offset = 0 then begin
          Result:= Result + NewStr;
          Break;
        end;
        chng:= True;
        Offset3:= 0;
        for j:= 0 to DefPattern.Count-1 do begin
            Offset2:= AnsiPos(DefPattern[j], NewStr);
            if Offset2 > 0 then begin
               if Copy(NewStr,Offset + Length(OldPattern[i]),Length(Patt))=
                  DefPattern[j] then begin
                  chng:= False;
                  Offset3:= Length(DefPattern[j]);
               end;
            end;
        end;

        if chng then begin
           Result:= Result + Copy(NewStr, 1, Offset - 1) + NewPattern[i];
           NewStr:= Copy(NewStr, Offset + Length(OldPattern[i]), MaxInt);
           Memo1.Lines.Add(OldPattern[i]+'->'+NewStr);
           S:= Result + NewStr;
           if not (rfReplaceAll in Flags) then begin
             Result := Result + NewStr;
             Break;
           end;
        end;
        SearchStr:= Copy(SearchStr, Offset + Length(Patt)+Offset3, MaxInt);
      end;
  end;
  if rfSelectLast in Flags then Result:= S1+Result;
end;

procedure TForm1.Button1Click(Sender: TObject);
          var oSL, nSL, dSL: TStringList;
begin
     oSL:= TStringList.Create;
     nSL:= TStringList.Create;
     dSL:= TStringList.Create;
     oSL.Assign(ListBox1.Items);
     nSL.Assign(ListBox2.Items);
     dSL.Assign(ListBox3.Items);
     Label2.Caption:= AddrReplace(Edit1.Text,oSL,nSL,dSL,xFlag);
     oSL.Free;
     nSL.Free;
     dSL.Free;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     if CheckBox1.Checked then xFlag:= xFlag + [rfSelectLast]
     else xFlag:= xFlag - [rfSelectLast];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     xFlag:= [rfReplaceAll];
end;

end.
